function b = applyA(x);
% multiply the vector x by matrix A
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global n nx ny

% put x back to 2D array
X = reshape(x,[nx,ny]);

% add the zero boundary condition
XX = zeros(nx+2,ny+2);
XX(2:end-1,2:end-1) = X;

X = XX;

% compute numerical Laplace
I = 2:nx+1; J = 2:ny+1; % inner points of the extended array

dxx_X = X(I+1,J)-2*X(I,J)+X(I-1,J);

dyy_X = X(I,J+1)-2*X(I,J)+X(I,J-1);

b = -dxx_X - dyy_X;

b = reshape(b,[n,1]);

