% conjugate_gradient_bild.m
% inverse edge detection
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; close all hidden;

global n     % matrix dimension
global nx ny % picture dimensions 



load('edges1');
[nx,ny] = size(edges);
imageview(edges);

n = nx*ny;

edges_vec = reshape(edges,[n,1]);


to_show = 0;

% construct back
F = edges_vec;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% now go by iteration
maxit = 200;
toler = 1e-10;

u = zeros(n,1);
r = F - applyA(u);

rho = r'*r;

res = nan(maxit,1);

figure(1)
U = reshape(u,[nx,ny]);
Pic=surf(flipud(U));
view(2); axis equal; axis tight; 
shading flat;
colormap gray;

for ctr = 1:maxit
    
    if ctr==1
        pk = r;
    else
        beta = rho/rho_k_minus_2;
        pk = r + beta*pk;
    end
    
    w = applyA(pk);
    alpha = rho/(pk'*w);
    
    u = u + alpha*pk;    
    r = r - alpha*w;
    
    rho_k_minus_2 = rho;
    rho = r'*r;
    
    
    res(ctr) = norm(r);
    if norm(r)<toler
        disp('cg converged');
        disp(['iteration ',num2str(ctr)]);
        break
    end
    
    if to_show==1
        U = reshape(u,[nx,ny]);
        set(Pic,'ZData',flipud(U));
        title(['iteration ',num2str(ctr)]);
        drawnow
    end
end


figure(2);
I = (1:maxit)';

%subplot(2,1,1);
semilogy(I,res,'b');
%axis([0 maxit 0 2]);

U = reshape(u,[nx,ny]);
imageview(U);


%subplot(2,1,2);
%semilogy(I,res.Jacobi,'b',I,res.GS,'g',I,res.relax,'r');
%legend('Jacobi','GS','relax');

